/*
 * info528, TP2 : générateurs pseudo aléatoires simples
 * NOM: Albus Dumbledore
 */

#include "tp2.h"

/*
 * calcule l'inverse de a modulo m
 * (renvoie 0 si a n'est pas premier avec m ou si le résultat est incorrect)
 */
long invert_mod(long a, long m){
    return 0;
}


/*
 * craque un générateur congruentiel en cherchant le module, puis les nombres
 * a et c à partir de nombre générés
 *
 * Le tableau 'random' contient les 'nb' premiers nombres générés.
 * La fonction renvoie 1 si le générateur trouvé génère bien la liste donnée et -1 sinon.
 */
int LCG_crack(int nb, long unsigned *random, long unsigned* a, long unsigned* c, long unsigned* m) {
    return -1;
}

/*
 * fonction auxiliaire: affiche un tableau d'entier comme une matrice de bits
 */
static void print_M(long unsigned *M, int nb_lignes) {
    for (int i=0;i<nb_lignes;i++) {
        print_bin(M[i],nb_lignes+1);
        printf("\n");
    }
    printf("\n");
}

/*
 * diagonalise une matrice booléenne de taille n x n+1
 */
int gauss(long unsigned *M, int nb_lignes) {
    return -1;
}

/*
 * craque un générateur linéaire "fibonacci" en cherchant les "taps" qui
 * permettent de regénérer la suite.
 * Le tableau 'random' contient les 'nb' premiers bits générés par le
 * générateur.
 * La fonction renvoie 1 si les taps permettent de regénérer la suite, et -1
 * sinon.
 */
int LFSR_crack(int nb, int *random, unsigned long* taps) {
    return -1;
}


/*
 * fonction de test, exécutée par l'argument '-T' de la ligne de commande
 */
void test() {
    printf("TESTS\n");
    printf("-----\n\n");

    printf("inverse modulo (question 1)\n");
    long a,b,m;
    m = 0x7fffffff;
    a = 12345;
    b = invert_mod(a,m);
    printf("L'inverse de %ld modulo %ld est %ld\n", a, m,b);
    printf("Vérification: %ld * %ld = %ld (mod %ld)\n", a, b, (a*b)%m, m);
}


